-- The main function is the first function called from Iguana.
-- The Data argument will contain the message to be processed.
require 'node'
require 'patientFHIR'

PatientXMLURL = 'http://hl7connect.healthintersections.com.au/svc/fhir/patient/@149?_format=xml'
AllPatientsXMLURL = 'http://hl7connect.healthintersections.com.au/svc/fhir/patient/search?_format=xml'
CreatePatientXMLURL = 'http://hl7connect.healthintersections.com.au/svc/fhir/patient?_format=xml'

function main(Data)
   
   print(patientFHIR,_G)
   local msg, name = hl7.parse({vmd = 'demo.vmd', data = Data})   
   local P = patientFHIR.InsertTemplate()
   P = mapPatientData(P,msg,name)
   
   -- read an individual patient in XML format from FHIR server
   -- reference http://www.hl7.org/implement/standards/fhir/patient.htm
   local R,C,H = net.http.get{url=PatientXMLURL, live=true}
   print (C,R,H)
   
   -- read all patient records in XML format from FHIR server
   -- reference http://www.hl7.org/implement/standards/fhir/http.htm#search
   R,C,H = net.http.get{url=AllPatientsXMLURL, live=true}
   print (C,R,H)
   
   -- create a new patient in FHIR server
   -- reference http://www.hl7.org/implement/standards/fhir/http.htm#create
   R,C,H = net.http.post{url=CreatePatientXMLURL, live=true,
                       headers={['Content-Type']='application/xml'},
                       body=P:S()
   }
   print (C,R,H) -- code 201 (c=201) is a successful insert
   
end

function mapPatientData(Xml,Msg,Name)
   if Name=='ADT' then
      Xml.Patient.active[1]='true'
      
      Xml.Patient.identifier.use[1]='official'
      Xml.Patient.identifier.label[1]='SSN'
      Xml.Patient.identifier.id[1]=Msg.PID[2][1]
      
      Xml.Patient.details.name.use.value='official'
      Xml.Patient.details.name.family.value=Msg.PID[5][1][1][1]
      Xml.Patient.details.name.given.value=Msg.PID[5][1][2]
      
      Xml.Patient.details.birthDate.value=Msg.PID[7][1]
      
      print(Msg.PID[8])
      Xml.Patient.details.gender.code[1]=Msg.PID[8]     
   end
   return Xml
end