-- Utilities for "node" Values

-- Coerce a node value into a string.
--
function node:S()
   return tostring(self)
end


-- return node value
function node:V()
   return node.nodeValue(self)
end


-- round node real number value to count of decimal places
function node.round(self, p)
   local o = 10^(p or 0)
   return math.floor(self:S()*o+0.5)/o
end


-- strip trailing field separator from all segments at once
function node.stripTrailingPipe(self)
   return self:S():gsub('|\r','\r')   
end